#ifndef Spieler_H
#define Spieler_H

#include <Bild.h>
#include <Datei.h>
#include <Random.h>

using namespace Framework;

enum SpielerTyp
{
    SPIELER,
    ZIEL,
    GEGNER
};

class Spieler : public virtual ReferenceCounter
{
private:
    double xPos;
    double yPos;
    double xSpeed;
    double ySpeed;
    double durchlssig;
    int farbe;

public:
    // Konstruktor
    Spieler( SpielerTyp typ, int mapBr, int mapH, RandomGenerator *zRand );
    Spieler( SpielerTyp typ, Datei *zD );
    Spieler();
    // Destruktor
    ~Spieler();
    // nicht constant
    void tick( double z, int mapBr, int mapH, char tastenStnde );
    void render( Bild &zRObj );
    // constant
    bool berhrt( double px, double py ) const;
    int getX() const;
    int getY() const;
    float getXSpeed() const;
    float getYSpeed() const;
    void save( Datei *zD ) const;
    Spieler *copy() const;
};

#endif